#include <cpp.h>     
#include <malloc.h>

//  Name:        dbsim.h
//
//  Title:       UW database simulator common declarations     
//
//  Change Activity:
//

// Configuration constants

#define DEFAULT_NUMTERMINALS     1
#define DEFAULT_NUMNODES        32
#define DEFAULT_BUFSIZE       1024  
#define DEFAULT_DISKSPERNODE 	 1
#define DEFAULT_CPUSPERNODE 	 1
#define DEFAULT_MIPS 	        20
#define DEFAULT_TUPSIZE        200
#define DEFAULT_KBYTESPERNODE 8192
#define DEFAULT_PAGESIZE      8192

#define MAX_OPSPERNODE 	       300
#define MAX_TERMINALS         1000
#define MAX_NODES               60
#define MAX_DISKSPERNODE        10
#define MAX_FILES             1500   /* includes relation and index files */
#define MAX_CLASSES            100

#define EXTENT_SIZE             64

// Flag constants

#define TRACE_BUF       0
#define TRACE_DISK      1 
#define TRACE_IO        2
#define TRACE_TERM      3
#define TRACE_SCHED     4
#define TRACE_OP        5
#define TRACE_MSG       6
#define TRACE_LOCK      7  
#define TRACE_QUERY     8
#define TRACE_PARSER    9
#define TRACE_CONTROL  10
#define MAXFLAGS       11    /* don't forget to update this guy too! */

// Misc constants
 
#define TERMINAL        0
#define NODE            1
#define SIMNAME         "ZetaSim"   /* for messages */


#define TRUE 1
#define FALSE 0
#define NOTOK 0
#define	OK 1
/* detect and identify error; return if error */
#define CKERR_RET(p,c)  if ((int)(c)!=OK) {\
	printf("%s %d\n", p, c); \
	return(c);\
}

// Type/class definitions

typedef int bool;

// Global variables

extern event SimDone;
extern int SimRunning;
extern bool Flags[];
extern bool Quiet;
extern int MsgLevel;
extern int NumClasses;
extern int NumTerminals;
extern int ActiveTerms;
extern int NumNodes;
extern int NumDiskNodes;
extern int DisksPerNode;
extern int CPUsPerNode;
extern int BufSize;
extern int PageSize;
extern int KBytesPerNode;
extern float Mips;

