
#include <dbsim.h>
#include <disk.h>

//------------------------------------------------------------------------
// class implementation for DiskCache
//------------------------------------------------------------------------

DiskCache::DiskCache()
{
    context = new CacheContext[DiskCacheContexts];
    for (int c = 0; c < DiskCacheContexts; c++) {
	context[c].firstCachedPage = NO_PAGE;
	context[c].lastCachedPage = NO_PAGE;
    }
    curContext = 0;
};

CacheContext* DiskCache::whichContext(int pageId)
{
    CacheContext* which = NULL;
    for (int c = 0; c < DiskCacheContexts; c++) {
	if ((pageId >= context[c].firstCachedPage) &&
	    (pageId <= context[c].lastCachedPage)) {
	    which = &(context[c]);
	}
    }
    return(which);
};

void DiskCache::print()
{
    printf("cache = [");
    for (int c = 0; c < DiskCacheContexts; c++) {
	printf(" ");
	if (c == curContext) { printf("*"); }
	printf("(%d, %d)", context[c].firstCachedPage,
	                   context[c].lastCachedPage);
	if (c == curContext) { printf("*"); }
    }
    printf("]");
};

