
#include <dbsim.h>
#include <disk.h>

//------------------------------------------------------------------------
// class implementation for Extent
//------------------------------------------------------------------------


Extent* Extent::freeExtDesc = NULL;        // no free descriptors initially


void* Extent::operator new(size_t size)
{
    Extent *newExt;

    if (freeExtDesc == NULL) {
	// allocate a new extent descriptor
	newExt = (Extent *) new char[size];
    } else {
	// reuse an existing extent descriptor
        newExt = freeExtDesc;
	freeExtDesc = freeExtDesc->nextFree;
    }
    return newExt;
};


void Extent::operator delete(void* oldExt, size_t)
{
    // put the disk request on the free list
    ((Extent *) oldExt)->nextFree = freeExtDesc;
    freeExtDesc = (Extent *) oldExt;
};

