//$Id: regrtest.s,v 1.5 1991/11/23 00:34:32 brown Exp $

// Weird files for boundary condition checking

file 01..10 = <numtuples=1, nodes={0}, disks={0}, tuplesize=1>;
file 11..20 = <numtuples=1000000, nodes={0}, disks={0}, tuplesize=1>;
file 21..30 = <numtuples=1, nodes={0}, disks={0}, tuplesize=1000>;

// Wisconsin relations, single node 

file 31..40 = <numtuples=100000, nodes={0}>;
file 41..50 = <numtuples=1000000, nodes={0}>;
file 51..60 = <numtuples=10000000, nodes={0}>;

// Wisconsin relations, fully declustered

file 61..70 = <numtuples=100000>;
file 71..80 = <numtuples=1000000>;
file 81..90 = <numtuples=10000000>;

// Weird indices (key size 1 and = tuple width)

index clix100K_k1_n1 = <id=91, keysize=1, file=31, type=clustered>;
index clix100K_k208_n1 = <id=92, keysize=208, file=33, type=clustered>;
index clix100K_k1_na = <id=93, keysize=1, file=61, type=clustered>;
index clix100K_k208_na = <id=94, keysize=208, file=63, type=clustered>;
index clix1M_k1_na = <id=95, keysize=1, file=71, type=clustered>;
index clix1M_k208_na = <id=96, keysize=208, file=73, type=clustered>;

// Clustered indices over single node relations

index 100..101 = <file=31, type=clustered>;
index 102..103 = <file=32, type=clustered>;
index 104..105 = <file=33, type=clustered>;
index 106..107 = <file=34, type=clustered>;
index 108..109 = <file=35, type=clustered>;

index 110..111 = <file=41, type=clustered>;
index 112..113 = <file=42, type=clustered>;
index 114..115 = <file=43, type=clustered>;
index 116..117 = <file=44, type=clustered>;
index 118..119 = <file=45, type=clustered>;

index 120..121 = <file=51, type=clustered>;
index 122..123 = <file=52, type=clustered>;
index 124..125 = <file=53, type=clustered>;
index 126..127 = <file=54, type=clustered>;
index 128..129 = <file=55, type=clustered>;

// Non-clustered indices over single node relations

index 130..131 = <file=31>, 132..133 = <file=32>, 134..135 = <file=33>,
      136..137 = <file=34>, 138..139 = <file=35>, 140..141 = <file=41>,
      142..143 = <file=42>, 144..145 = <file=43>, 146..147 = <file=44>,
      148..149 = <file=45>, 150..151 = <file=51>, 152..153 = <file=52>,
      154..155 = <file=53>, 156..157 = <file=54>, 158..159 = <file=55>;

// Clustered indices over fully declustered relations

index 160..161 = <file=61, type=clustered>;
index 162..163 = <file=62, type=clustered>;
index 164..165 = <file=63, type=clustered>;
index 166..167 = <file=64, type=clustered>;
index 168..169 = <file=65, type=clustered>;

index 170..171 = <file=71, type=clustered>;
index 172..173 = <file=72, type=clustered>;
index 174..175 = <file=73, type=clustered>;
index 176..177 = <file=74, type=clustered>;
index 178..179 = <file=75, type=clustered>;

index 180..181 = <file=81, type=clustered>;
index 182..183 = <file=82, type=clustered>;
index 184..185 = <file=83, type=clustered>;
index 186..187 = <file=84, type=clustered>;
index 188..189 = <file=85, type=clustered>;

// Non-clustered indices over fully declustered relations

index 190..191 = <file=61>, 192..193 = <file=62>, 194..195 = <file=63>,
      196..197 = <file=64>, 198..199 = <file=65>, 200..201 = <file=71>,
      202..203 = <file=72>, 204..205 = <file=73>, 206..207 = <file=74>,
      208..209 = <file=75>, 210..211 = <file=81>, 212..213 = <file=82>,
      214..215 = <file=83>, 216..217 = <file=84>, 218..219 = <file=85>;

///////////////////////////////////////////////////////////////////////////////

// Uniform selection of all relation types, for low data sharing

file f1_w1_n1_d1 = uniform(1, 10);
file f1M_w1_n1_d1 = uniform(11, 20);
file f1_w1K_n1_d1 = uniform(21, 30);
file f100K_w208_n1_da = uniform(31, 40);
file f1M_w208_n1_da = uniform(41, 50);
file f10M_w208_n1_da = uniform(51, 60);
file f100K_w208_na_da = uniform(61, 70);
file f1M_w208_na_da = uniform(71, 80);
file f10M_w208_na_da = uniform(81, 90);

// Sharam/Livny distribution of fully declustered relations for hi data sharing

file hisharing_100K = [61/.48, 62/.32, 63/.15, 64/.04, 65/.01]; // Livny distr.
file hisharing_1M = [71/.48, 72/.32, 73/.15, 74/.04, 75/.01]; // Livny distr.
file hisharing_10M = [81/.48, 82/.32, 83/.15, 84/.04, 85/.01]; // Livny distr.

// Random classes of indices

index clix_100K_n1 = uniform(100, 109), 
      clix_1M_n1 = uniform(110, 119),
      clix_10M_n1 = uniform(120, 129);
index nclix_100K_n1 = uniform(130, 139), 
      nclix_1M_n1 = uniform(140, 149),
      nclix_10M_n1 = uniform(150, 159);

index clix_100K_na = uniform(160, 169), 
      clix_1M_na = uniform(170, 179),
      clix_10M_na = uniform(180, 189);
index nclix_100K_na = uniform(190, 199), 
      nclix_1M_na = uniform(200, 209),
      nclix_10M_na = uniform(210, 219);

index nclix_n1 = uniform(130, 159); // uniform, nclix, single node
index clix_n1 =  uniform(100, 129); // uniform, clix, single node
index index_n1 = uniform(100, 159);       // uniform, single node

index nclix_na = uniform(190, 219); // uniform, nclix, fully declustered
index clix_na =  uniform(160, 189); // uniform, clix, fully declustered
index index_na = uniform(160, 219);       // uniform, fully declustered

index index_na80_n120 = [index_na/.8, index_n1/.2];
index nclix80_clix20_n1 = [nclix_n1/.8, clix_n1/.2];
index nclix80_clix20_na = [nclix_na/.8, clix_na/.2];

// Some interesting selectivities and projection percentages for this database

real singleTuple100KSel = .00002,
     singleTuple1MSel = .000002,
     singleTuple10MSel = .0000002,
     point_sel = 0;
